From 520184236cc4983627615022bf0d45630f261b08 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:11 +0000
Subject: [PATCH 738/1001] Build the API documentation with Sphinx


---

diff --git a/docs/conf.py b/docs/conf.py
index ca55b4f..27b4be2 100644
--- a/docs/conf.py
+++ b/docs/conf.py
@@ -16,20 +16,25 @@
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
 #
-# import os
-# import sys
-# sys.path.insert(0, os.path.abspath('.'))
+import os
+import sys
+sys.path.insert(0, os.path.abspath('..'))
 
 # -- General configuration ------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
 #
-# needs_sphinx = '1.0'
+needs_sphinx = '1.3'
 
 # Add any Sphinx extension module names here, as strings. They can be
 # extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
 # ones.
-extensions = []
+extensions = [
+    'sphinx.ext.autodoc',
+    'sphinx.ext.doctest',
+    'sphinx.ext.napoleon',
+    'sphinx.ext.viewcode',
+]
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 6d5f257..a4cafba 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -1,4 +1,79 @@
 """
+First, some definitions:
+
+- A *widget* is a Python class inheriting from
+  :py:class:`hubs.widgets.base.Widget`.
+  It will be registered with the application in the
+  :py:data:`hubs.widgets.registry` dictionary.
+- A *widget instance* is a database record (:py:class:`hubs.models.Widget`), it
+  means that a particular *widget* has been set up for a particular *hub*, with
+  a specific configuration.  A *widget* can be set up more that one time for
+  the same *hub*, with different configurations (for example, the ``sticky``
+  widget).  In this case, there will one *widget* but multiple *widget
+  instances*.
+
+As explained above, widgets are Python classes.  They are best isolated in
+their own module and directory.  To create a new widget, you can follow these
+steps:
+
+- create a new directory in ``hubs/widgets/``
+- write your widget subclass in the ``__init__.py`` file
+- reference the class in your configuration file, or in the general
+  ``hubs/default_config.py`` configuration file.
+
+In order to be valid, a widget must:
+
+- inherit from the :py:class:`hubs.widgets.base.Widget` class,
+- have a valid :py:attr:`~hubs.widgets.base.Widget.name` attribute,
+- have a valid :py:attr:`~hubs.widgets.base.Widget.position` attribute,
+- contain at least one view named "``root``", registered for the "``/``" URL.
+  See the description of widget views below for details.
+
+A widget view is a class which inherits from the
+:py:class:`hubs.widgets.view.WidgetView` class.  A widget can have one or more
+of them.
+
+Widget views can make use of templates following the Jinja2 engine syntax.  The
+templates are looked for in the widget's ``templates`` subdirectrory first, and
+then in the generic ``hubs/widgets/templates/`` directory.  They can make use
+of any Jinja2 feature, including inheritance, macros, etc.
+
+If you want to add filters to youre widget's Jinja2 environment, you can do so
+by overriding the widget's
+:py:meth:`~hubs.widgets.base.Widget.get_template_environment` method.
+
+Hubs provides the ``panel.html`` master template for widgets that want their
+output to be wrapped in the common panel chrome, just use the ``extends`` tag
+to take advantage of it.  You can also set a ``title`` variable in your root
+view context, and it will be used for the panel title.
+
+Refer to the API documentation to learn more on how to write a widget view.
+
+A widget can also have any number of cached functions.  A cached function is a
+subclass of :py:class:`hubs.widgets.caching.CachedFunction`.
+
+The result is cached until a bus message is recieved that marks the former
+result as invalid.  To filter which messages are relevant, a cached function
+has a
+:py:meth:`~hubs.widgets.caching.CachedFunction.should_invalidate(message)`
+method that returns ``True`` if the cached result is obsolete, ``False``
+otherwise.  A backend daemon will call this method on each incoming bus
+message.
+
+Refer to the API documentation to learn more on how to write a cached function.
+
+If you want it to show up on a new **user** page, add it to
+:py:mod:`hubs.defaults` in the :py:func:`add_user_widgets` function.  If you
+want it to show up on new **group** pages, add it to the
+:py:func:`add_group_widgets` function in the same module.  If you want your
+widget to be part of the example hubs created by default, add it to
+``populate.py``.  Then destroy your database, rebuild it, and re-run the app.
+Your widget should show up.
+
+Feel free to look at existing widgets for inspiration.
+
+The widget registry is instanciated in this module, as :py:data:`registry`.
+
 Attributes:
     registry (dict): This dictionary is a registry of available widgets in
         Fedora Hubs.
diff --git a/tox.ini b/tox.ini
index 24d3f29..03e75ca 100644
--- a/tox.ini
+++ b/tox.ini
@@ -30,7 +30,9 @@ commands =
 
 [testenv:docs]
 changedir = docs
-deps = sphinx
+deps =
+    -rrequirements.txt
+    sphinx
 whitelist_externals =
     mkdir
 commands=

